(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var _ = Package.underscore._;
var Random = Package.random.Random;
var Router = Package['iron:router'].Router;
var RouteController = Package['iron:router'].RouteController;
var SandstormDb = Package['sandstorm-db'].SandstormDb;
var SandstormEmail = Package['sandstorm-email'].SandstormEmail;
var Accounts = Package['accounts-base'].Accounts;
var check = Package.check.check;
var Match = Package.check.Match;
var SHA256 = Package.sha.SHA256;
var Email = Package.email.Email;
var EmailInternals = Package.email.EmailInternals;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;
var Iron = Package['iron:core'].Iron;

var require = meteorInstall({"node_modules":{"meteor":{"accounts-email-token":{"token_common.js":function(){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/accounts-email-token/token_common.js                                                                 //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
Accounts.emailToken = {};                                                                                        // 1
                                                                                                                 //
Accounts.emailToken._hashToken = function (token) {                                                              // 3
  return {                                                                                                       // 4
    digest: SHA256(token),                                                                                       // 5
    algorithm: "sha-256"                                                                                         // 6
  };                                                                                                             // 4
};                                                                                                               // 8
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

},"token_server.js":["crypto",function(require){

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                               //
// packages/accounts-email-token/token_server.js                                                                 //
//                                                                                                               //
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                 //
var _crypto = require("crypto");                                                                                 // 1
                                                                                                                 //
var _crypto2 = _interopRequireDefault(_crypto);                                                                  //
                                                                                                                 //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }                //
                                                                                                                 //
var V1_ROUNDS = 4096; // Selected to take ~5msec at creation time (2016) on a developer's laptop.                // 3
var V1_KEYSIZE = 32; // 256 bits / 8 bits/byte = 32 bytes                                                        // 4
var V1_HASHFUNC = "sha512";                                                                                      // 5
// ^ hash function used with pbkdf2.  Chosen to be different from the function which maps the token              //
// to the value stored in the database.  Note that the first thing that pbkdf2 does is                           //
// HMAC(HASHFUNC, key, salt), and the first thing that HMAC does is either pad or hash the key to                //
// make it the appropriate width.  The result is that knowing sha256(key) and the salt is possibly               //
// sufficient to reconstruct the output of pbkdf2().                                                             //
var V1_CIPHER = "AES-256-CTR"; // cipher used                                                                    // 11
                                                                                                                 //
var TOKEN_EXPIRATION_MS = 15 * 60 * 1000;                                                                        // 13
                                                                                                                 //
var cleanupExpiredTokens = function cleanupExpiredTokens() {                                                     // 15
  Meteor.users.update({                                                                                          // 16
    "services.email.tokens.createdAt": {                                                                         // 17
      $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS)                                                            // 18
    }                                                                                                            // 17
  }, {                                                                                                           // 16
    $pull: {                                                                                                     // 21
      "services.email.tokens": {                                                                                 // 22
        createdAt: { $lt: new Date(Date.now() - TOKEN_EXPIRATION_MS) }                                           // 23
      }                                                                                                          // 22
    }                                                                                                            // 21
  }, {                                                                                                           // 20
    multi: true                                                                                                  // 27
  });                                                                                                            // 26
};                                                                                                               // 29
                                                                                                                 //
Meteor.startup(cleanupExpiredTokens);                                                                            // 31
// Tokens can actually last up to 2 * TOKEN_EXPIRATION_MS                                                        //
SandstormDb.periodicCleanup(TOKEN_EXPIRATION_MS, cleanupExpiredTokens);                                          // 33
                                                                                                                 //
var checkToken = function checkToken(tokens, token) {                                                            // 35
  // Looks for an object in `tokens` with `algorithm` and `digest` fields matching those in `token`.             //
  // Returns the matching object, if one is found, or undefined if none match.                                   //
  var foundToken = undefined;                                                                                    // 38
  tokens.forEach(function (userToken) {                                                                          // 39
    if (userToken.algorithm === token.algorithm && userToken.digest === token.digest) {                          // 40
      foundToken = userToken;                                                                                    // 42
    }                                                                                                            // 43
  });                                                                                                            // 44
                                                                                                                 //
  return foundToken;                                                                                             // 46
};                                                                                                               // 47
                                                                                                                 //
function consumeToken(user, token) {                                                                             // 49
  var hashedToken = Accounts.emailToken._hashToken(token);                                                       // 50
  var foundToken = checkToken(user.services.email.tokens, hashedToken);                                          // 51
                                                                                                                 //
  if (foundToken !== undefined) {                                                                                // 53
    Meteor.users.update({ _id: user._id }, { $pull: { "services.email.tokens": hashedToken } });                 // 54
  }                                                                                                              // 55
                                                                                                                 //
  return foundToken;                                                                                             // 57
}                                                                                                                // 58
                                                                                                                 //
// Handler to login with a token.                                                                                //
Accounts.registerLoginHandler("email", function (options) {                                                      // 61
  if (!options.email) {                                                                                          // 62
    return undefined; // don't handle                                                                            // 63
  }                                                                                                              // 64
                                                                                                                 //
  if (!Accounts.identityServices.email.isEnabled()) {                                                            // 66
    throw new Meteor.Error(403, "Email identity service is disabled.");                                          // 67
  }                                                                                                              // 68
                                                                                                                 //
  options = options.email;                                                                                       // 70
  check(options, {                                                                                               // 71
    email: String,                                                                                               // 72
    token: String                                                                                                // 73
  });                                                                                                            // 71
                                                                                                                 //
  var user = Meteor.users.findOne({                                                                              // 76
    "services.email.email": options.email                                                                        // 77
  }, {                                                                                                           // 76
    fields: {                                                                                                    // 79
      "services.email": 1                                                                                        // 80
    }                                                                                                            // 79
  });                                                                                                            // 78
                                                                                                                 //
  if (!user) {                                                                                                   // 84
    console.error("User not found:", options.email);                                                             // 85
    return {                                                                                                     // 86
      error: new Meteor.Error(403, "User not found")                                                             // 87
    };                                                                                                           // 86
  }                                                                                                              // 89
                                                                                                                 //
  if (!user.services.email.tokens) {                                                                             // 91
    console.error("User has no token set:", options.email);                                                      // 92
    return {                                                                                                     // 93
      error: new Meteor.Error(403, "User has no token set")                                                      // 94
    };                                                                                                           // 93
  }                                                                                                              // 96
                                                                                                                 //
  var tokenString = options.token.trim();                                                                        // 98
  var maybeToken = consumeToken(user, tokenString);                                                              // 99
  if (!maybeToken) {                                                                                             // 100
    console.error("Token not found:", options.email);                                                            // 101
    return {                                                                                                     // 102
      error: new Meteor.Error(403, "Invalid authentication code")                                                // 103
    };                                                                                                           // 102
  }                                                                                                              // 105
                                                                                                                 //
  // Attempt to decrypt the resumePath, if provided.                                                             //
  var resumePath = undefined;                                                                                    // 108
  if (maybeToken.secureBox) {                                                                                    // 109
    var box = maybeToken.secureBox;                                                                              // 110
    if (box.version === 1) {                                                                                     // 111
      var key = _crypto2["default"].pbkdf2Sync(tokenString, box.salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);       // 112
      var iv = new Buffer(box.iv, "base64");                                                                     // 113
      var cipher = _crypto2["default"].createDecipheriv(V1_CIPHER, key, iv);                                     // 114
      var cipherText = new Buffer(box.boxedValue, "base64");                                                     // 115
      var plaintext = cipher.update(cipherText);                                                                 // 116
      resumePath = plaintext.toString("binary");                                                                 // 117
    }                                                                                                            // 118
  }                                                                                                              // 119
                                                                                                                 //
  return {                                                                                                       // 121
    userId: user._id,                                                                                            // 122
    options: {                                                                                                   // 123
      resumePath: resumePath                                                                                     // 124
    }                                                                                                            // 123
  };                                                                                                             // 121
});                                                                                                              // 127
                                                                                                                 //
var Url = Npm.require("url");                                                                                    // 129
                                                                                                                 //
var ROOT_URL = Url.parse(process.env.ROOT_URL);                                                                  // 131
var HOSTNAME = ROOT_URL.hostname;                                                                                // 132
                                                                                                                 //
var makeTokenUrl = function makeTokenUrl(email, token, linkingIdentity) {                                        // 134
  if (linkingIdentity) {                                                                                         // 135
    return process.env.ROOT_URL + "/_emailLinkIdentity/" + encodeURIComponent(email) + "/" + encodeURIComponent(token) + "/" + Meteor.userId();
  } else {                                                                                                       // 138
    return process.env.ROOT_URL + "/_emailLogin/" + encodeURIComponent(email) + "/" + encodeURIComponent(token);
  }                                                                                                              // 141
};                                                                                                               // 142
                                                                                                                 //
///                                                                                                              //
/// EMAIL VERIFICATION                                                                                           //
///                                                                                                              //
var sendTokenEmail = function sendTokenEmail(db, email, token, linkingIdentity) {                                // 147
  var subject = void 0;                                                                                          // 148
  var text = void 0;                                                                                             // 149
  if (!linkingIdentity) {                                                                                        // 150
    subject = "Log in to " + HOSTNAME;                                                                           // 151
    text = "To confirm this email address on ";                                                                  // 152
  } else {                                                                                                       // 153
    subject = "Confirm this email address on " + HOSTNAME;                                                       // 154
    text = "To confirm this email address on ";                                                                  // 155
  }                                                                                                              // 156
                                                                                                                 //
  text = text + HOSTNAME + ", click on the following link:\n\n" + makeTokenUrl(email, token, linkingIdentity) + "\n\n" + "Alternatively, enter the following one-time authentication code into the log-in form:\n\n" + token;
                                                                                                                 //
  var options = {                                                                                                // 163
    to: email,                                                                                                   // 164
    from: db.getServerTitle() + " <" + db.getReturnAddress() + ">",                                              // 165
    subject: subject,                                                                                            // 166
    text: text                                                                                                   // 167
  };                                                                                                             // 163
                                                                                                                 //
  SandstormEmail.send(options);                                                                                  // 170
};                                                                                                               // 171
                                                                                                                 //
///                                                                                                              //
/// CREATING USERS                                                                                               //
///                                                                                                              //
// returns the user id                                                                                           //
var _createAndEmailTokenForUser = function _createAndEmailTokenForUser(db, email, linkingIdentity, resumePath) {
  check(email, String);                                                                                          // 178
  check(linkingIdentity, Boolean);                                                                               // 179
  check(resumePath, String);                                                                                     // 180
                                                                                                                 //
  var atIndex = email.indexOf("@");                                                                              // 182
  if (atIndex === -1) {                                                                                          // 183
    throw new Meteor.Error(400, "No @ symbol was found in your email");                                          // 184
  }                                                                                                              // 185
                                                                                                                 //
  var user = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });       // 187
  var userId = void 0;                                                                                           // 189
                                                                                                                 //
  // TODO(someday): make this shorter, and handle requests that try to brute force it.                           //
  // Alternately, require using the link over copy/pasting the code, and crank up the entropy.                   //
  var token = Random.id(12);                                                                                     // 193
  var tokenObj = Accounts.emailToken._hashToken(token);                                                          // 194
  tokenObj.createdAt = new Date();                                                                               // 195
                                                                                                                 //
  // Produce a symmetric key.  Note that the token itself does not have sufficient entropy to                    //
  // be used as a key directly, so we need to use a KDF with a strong random salt.                               //
  // In the fullness of time, it might be nice to move away from using a KDF (which blocks the whole             //
  // node process) in favor of the token itself having enough entropy to serve as the key itself.                //
  // This would require lengthening the token, which would make the manual-code-entry workflow                   //
  // worse, so I'm punting on that for now.                                                                      //
  var salt = Random.secret(16);                                                                                  // 203
  var key = _crypto2["default"].pbkdf2Sync(token, salt, V1_ROUNDS, V1_KEYSIZE, V1_HASHFUNC);                     // 204
  var iv = _crypto2["default"].randomBytes(16);                                                                  // 205
  var cipher = _crypto2["default"].createCipheriv(V1_CIPHER, key, iv);                                           // 206
  var ciphertext = cipher.update(new Buffer(resumePath, "binary"));                                              // 207
  tokenObj.secureBox = {                                                                                         // 208
    version: 1,                                                                                                  // 209
    salt: salt,                                                                                                  // 210
    iv: iv.toString("base64"),                                                                                   // 211
    boxedValue: ciphertext.toString("base64")                                                                    // 212
  };                                                                                                             // 208
                                                                                                                 //
  if (user) {                                                                                                    // 215
    if (user.services.email.tokens && user.services.email.tokens.length > 2) {                                   // 216
      throw new Meteor.Error(409, "It looks like we sent a log in email to this address not long " + "ago. Please use the one that was already sent (check your spam folder if you can't find " + "it), or wait a while and try again");
    }                                                                                                            // 220
                                                                                                                 //
    userId = user._id;                                                                                           // 222
                                                                                                                 //
    Meteor.users.update({ _id: user._id }, { $push: { "services.email.tokens": tokenObj } });                    // 224
  } else {                                                                                                       // 225
    var options = {};                                                                                            // 226
    user = {                                                                                                     // 227
      services: {                                                                                                // 228
        email: {                                                                                                 // 229
          tokens: [tokenObj],                                                                                    // 230
          email: email                                                                                           // 231
        }                                                                                                        // 229
      }                                                                                                          // 228
    };                                                                                                           // 227
                                                                                                                 //
    userId = Accounts.insertUserDoc(options, user);                                                              // 236
  }                                                                                                              // 237
                                                                                                                 //
  sendTokenEmail(db, email, token, linkingIdentity);                                                             // 239
                                                                                                                 //
  return userId;                                                                                                 // 241
};                                                                                                               // 242
                                                                                                                 //
Meteor.methods({                                                                                                 // 244
  createAndEmailTokenForUser: function createAndEmailTokenForUser(email, linkingIdentity, resumePath) {          // 245
    // method for create user. Requests come from the client.                                                    //
    // This method will create a user if it doesn't exist, otherwise it will generate a token.                   //
    // It will always send an email to the user                                                                  //
                                                                                                                 //
    check(email, String);                                                                                        // 250
    check(linkingIdentity, Boolean);                                                                             // 251
    check(resumePath, String);                                                                                   // 252
                                                                                                                 //
    if (!Accounts.identityServices.email.isEnabled()) {                                                          // 254
      throw new Meteor.Error(403, "Email identity service is disabled.");                                        // 255
    }                                                                                                            // 256
    // Create user. result contains id and token.                                                                //
    var user = _createAndEmailTokenForUser(this.connection.sandstormDb, email, linkingIdentity, resumePath);     // 258
  },                                                                                                             // 259
                                                                                                                 //
  linkEmailIdentityToAccount: function linkEmailIdentityToAccount(email, token) {                                // 261
    // Links the email identity with address `email` and login token `token` to the current account.             //
    check(email, String);                                                                                        // 263
    check(token, String);                                                                                        // 264
    var account = Meteor.user();                                                                                 // 265
    if (!account || !account.loginIdentities) {                                                                  // 266
      throw new Meteor.Error(403, "Must be logged in to an account to link an email identity.");                 // 267
    }                                                                                                            // 268
                                                                                                                 //
    var identity = Meteor.users.findOne({ "services.email.email": email }, { fields: { "services.email": 1 } });
    if (!identity) {                                                                                             // 272
      throw new Meteor.Error(403, "Invalid authentication code.");                                               // 273
    }                                                                                                            // 274
                                                                                                                 //
    var maybeToken = consumeToken(identity, token.trim());                                                       // 276
    if (!maybeToken) {                                                                                           // 277
      throw new Meteor.Error(403, "Invalid authentication code.");                                               // 278
    }                                                                                                            // 279
                                                                                                                 //
    Accounts.linkIdentityToAccount(this.connection.sandstormDb, this.connection.sandstormBackend, identity._id, account._id);
  }                                                                                                              // 283
});                                                                                                              // 244
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/accounts-email-token/token_common.js");
require("./node_modules/meteor/accounts-email-token/token_server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
Package['accounts-email-token'] = {};

})();

//# sourceMappingURL=accounts-email-token.js.map
