(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var check = Package.check.check;
var Match = Package.check.Match;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var SandstormPowerboxRequest;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-ui-powerbox":{"powerbox-server.js":["babel-runtime/helpers/classCallCheck",function(require){

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                              //
// packages/sandstorm-ui-powerbox/powerbox-server.js                                                            //
//                                                                                                              //
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                //
var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");                                         //
                                                                                                                //
var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);                                                //
                                                                                                                //
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }               //
                                                                                                                //
// Sandstorm - Personal Cloud Sandbox                                                                           //
// Copyright (c) 2016 Sandstorm Development Group, Inc. and contributors                                        //
// All rights reserved.                                                                                         //
//                                                                                                              //
// Licensed under the Apache License, Version 2.0 (the "License");                                              //
// you may not use this file except in compliance with the License.                                             //
// You may obtain a copy of the License at                                                                      //
//                                                                                                              //
//   http://www.apache.org/licenses/LICENSE-2.0                                                                 //
//                                                                                                              //
// Unless required by applicable law or agreed to in writing, software                                          //
// distributed under the License is distributed on an "AS IS" BASIS,                                            //
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                     //
// See the License for the specific language governing permissions and                                          //
// limitations under the License.                                                                               //
                                                                                                                //
var Capnp = Npm.require("capnp");                                                                               // 17
var Powerbox = Capnp.importSystem("sandstorm/powerbox.capnp");                                                  // 18
var Grain = Capnp.importSystem("sandstorm/grain.capnp");                                                        // 19
var Ip = Capnp.importSystem("sandstorm/ip.capnp");                                                              // 20
var Email = Capnp.importSystem("sandstorm/email.capnp");                                                        // 21
                                                                                                                //
function encodePowerboxDescriptor(desc) {                                                                       // 23
  return Capnp.serializePacked(Powerbox.PowerboxDescriptor, desc).toString("base64").replace(/\+/g, "-").replace(/\//g, "_");
}                                                                                                               // 28
                                                                                                                //
Meteor.methods({                                                                                                // 30
  newFrontendRef: function newFrontendRef(sessionId, frontendRefVariety) {                                      // 31
    // Checks if the requester is an admin, and if so, provides a new frontendref of the desired                //
    // variety, provided by the requesting user, owned by the grain for this session.                           //
    check(sessionId, String);                                                                                   // 34
    check(frontendRefVariety, Match.OneOf({ ipNetwork: true }, { ipInterface: true }, { emailVerifier: { services: Match.Optional([String]) } }, { verifiedEmail: { verifierId: Match.Optional(String), address: String } }));
                                                                                                                //
    var db = this.connection.sandstormDb;                                                                       // 42
                                                                                                                //
    var session = db.collections.sessions.findOne(sessionId);                                                   // 44
    if (!session) {                                                                                             // 45
      throw new Meteor.Error(403, "Invalid session ID");                                                        // 46
    }                                                                                                           // 47
                                                                                                                //
    var descriptor = void 0;                                                                                    // 49
    var requirements = [];                                                                                      // 50
    if (frontendRefVariety.ipNetwork) {                                                                         // 51
      if (!db.isAdmin(this.userId)) {                                                                           // 52
        throw new Meteor.Error(403, "User must be an admin to powerbox offer IpNetwork");                       // 53
      }                                                                                                         // 54
                                                                                                                //
      descriptor = encodePowerboxDescriptor({ tags: [{ id: Ip.IpNetwork.typeId }] });                           // 56
      requirements.push({ userIsAdmin: Meteor.userId() });                                                      // 57
    } else if (frontendRefVariety.ipInterface) {                                                                // 58
      if (!db.isAdmin(this.userId)) {                                                                           // 59
        throw new Meteor.Error(403, "User must be an admin to powerbox offer IpInterface");                     // 60
      }                                                                                                         // 61
                                                                                                                //
      descriptor = encodePowerboxDescriptor({ tags: [{ id: Ip.IpInterface.typeId }] });                         // 63
      requirements.push({ userIsAdmin: Meteor.userId() });                                                      // 64
    } else if (frontendRefVariety.emailVerifier) {                                                              // 65
      var services = frontendRefVariety.emailVerifier.services;                                                 // 66
      if (services) {                                                                                           // 67
        services.forEach(function (service) {                                                                   // 68
          if (!Accounts.identityServices[service]) {                                                            // 69
            throw new Error("No such identity service: " + service);                                            // 70
          }                                                                                                     // 71
        });                                                                                                     // 72
      }                                                                                                         // 73
                                                                                                                //
      descriptor = encodePowerboxDescriptor({ tags: [{ id: Email.EmailVerifier.typeId }] });                    // 75
    } else if (frontendRefVariety.verifiedEmail) {                                                              // 76
      // Verify that the address actually belongs to the user.                                                  //
                                                                                                                //
      if (!_.contains(getVerifiedEmails(db, this.userId, frontendRefVariety.verifiedEmail.verifierId), frontendRefVariety.verifiedEmail.address)) {
        throw new Meteor.Error(403, "User has no such verified address");                                       // 82
      }                                                                                                         // 83
                                                                                                                //
      // Add the session's tabId.                                                                               //
      frontendRefVariety.verifiedEmail.tabId = session.tabId;                                                   // 86
                                                                                                                //
      // Build the descriptor, which contains the verifier ID.                                                  //
      var tagValue = frontendRefVariety.verifiedEmail.verifierId && Capnp.serialize(Email.VerifiedEmail.PowerboxTag, { verifierId: new Buffer(frontendRefVariety.verifiedEmail.verifierId, "hex") });
      descriptor = encodePowerboxDescriptor({                                                                   // 92
        tags: [{ id: Email.VerifiedEmail.typeId, value: tagValue }]                                             // 93
      });                                                                                                       // 92
    } else {                                                                                                    // 95
      throw new Meteor.Error(500, "Unimplemented frontendRef type");                                            // 96
    }                                                                                                           // 97
                                                                                                                //
    var grainId = session.grainId;                                                                              // 99
    var apiTokenOwner = {                                                                                       // 100
      clientPowerboxRequest: {                                                                                  // 101
        grainId: grainId,                                                                                       // 102
        introducerIdentity: session.identityId,                                                                 // 103
        sessionId: session._id                                                                                  // 104
      }                                                                                                         // 101
    };                                                                                                          // 100
                                                                                                                //
    // TODO(cleanup): refactor: reaches out into core.js                                                        //
    var sturdyRef = waitPromise(saveFrontendRef(frontendRefVariety, apiTokenOwner, requirements)).sturdyRef.toString();
    return { sturdyRef: sturdyRef, descriptor: descriptor };                                                    // 110
  },                                                                                                            // 111
  fulfillUiViewRequest: function fulfillUiViewRequest(sessionId, identityId, grainId, petname, roleAssignment, ownerGrainId) {
    var db = this.connection.sandstormDb;                                                                       // 114
    check(sessionId, String);                                                                                   // 115
    check(identityId, String);                                                                                  // 116
    check(grainId, String);                                                                                     // 117
    check(roleAssignment, db.roleAssignmentPattern);                                                            // 118
    check(petname, String);                                                                                     // 119
    check(ownerGrainId, String);                                                                                // 120
                                                                                                                //
    if (!this.userId || !db.userHasIdentity(this.userId, identityId)) {                                         // 122
      throw new Meteor.Error(403, "Not an identity of the current user: " + identityId);                        // 123
    }                                                                                                           // 124
                                                                                                                //
    var provider = {                                                                                            // 126
      identityId: identityId,                                                                                   // 127
      accountId: this.userId                                                                                    // 128
    };                                                                                                          // 126
                                                                                                                //
    var title = db.userGrainTitle(grainId, this.userId, identityId);                                            // 131
                                                                                                                //
    var descriptor = encodePowerboxDescriptor({                                                                 // 133
      tags: [{ id: Grain.UiView.typeId,                                                                         // 134
        value: Capnp.serialize(Grain.UiView.PowerboxTag, { title: title })                                      // 136
      }]                                                                                                        // 135
    });                                                                                                         // 133
                                                                                                                //
    var owner = {                                                                                               // 141
      clientPowerboxRequest: {                                                                                  // 142
        grainId: ownerGrainId,                                                                                  // 143
        introducerIdentity: identityId,                                                                         // 144
        sessionId: sessionId                                                                                    // 145
      }                                                                                                         // 142
    };                                                                                                          // 141
                                                                                                                //
    var result = SandstormPermissions.createNewApiToken(db, provider, grainId, petname, roleAssignment, owner);
                                                                                                                //
    return {                                                                                                    // 152
      sturdyRef: result.token,                                                                                  // 153
      descriptor: descriptor                                                                                    // 154
    };                                                                                                          // 152
  }                                                                                                             // 156
});                                                                                                             // 30
                                                                                                                //
var PowerboxOption = function () {                                                                              //
  function PowerboxOption(fields) {                                                                             // 160
    (0, _classCallCheck3["default"])(this, PowerboxOption);                                                     // 160
                                                                                                                //
    _.extend(this, fields);                                                                                     // 161
  }                                                                                                             // 162
                                                                                                                //
  PowerboxOption.prototype.intersect = function intersect(other) {                                              //
    // Intersect two options with the same ID. Used when combining matches from multiple tags                   //
    // in the same descriptor. The tags are a conjunction.                                                      //
    //                                                                                                          //
    // Returns true if there was any overlap, or false if there was no overlap and therefore the                //
    // option should be dropped.                                                                                //
                                                                                                                //
    if (other._id != this._id) {                                                                                // 171
      throw new Error("can only merge options with the same ID");                                               // 172
    }                                                                                                           // 173
                                                                                                                //
    if (other.grainId) {                                                                                        // 175
      if (this.uiView && !other.uiView) delete this.uiView;                                                     // 176
      if (this.hostedObject && !other.hostedObject) delete this.hostedObject;                                   // 177
      return !!(this.uiView || this.hostedObject);                                                              // 178
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                        // 179
      // Try to hint which verifierId matched.                                                                  //
      if (this.frontendRef.verifiedEmail.verifierId) {                                                          // 181
        if (other.frontendRef.verifiedEmail.verifierId) {                                                       // 182
          // Can't match multiple verifiers at once.                                                            //
          return false;                                                                                         // 184
        }                                                                                                       // 185
      } else if (other.frontendRef.verifiedEmail.verifierId) {                                                  // 186
        // One request did not specify any verifierId, the other did, and both matched, so use                  //
        // the verifierId.                                                                                      //
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                 // 189
      }                                                                                                         // 190
                                                                                                                //
      return true;                                                                                              // 192
    } else {                                                                                                    // 193
      // No intersection logic needed for other types.                                                          //
      return true;                                                                                              // 195
    }                                                                                                           // 196
  };                                                                                                            // 197
                                                                                                                //
  PowerboxOption.prototype.union = function union(other) {                                                      //
    // Union two options with the same ID. Used when combining matches from multiple descriptors.               //
    // The descriptors are a disjunction.                                                                       //
                                                                                                                //
    if (other._id != this._id) {                                                                                // 203
      throw new Error("can only merge options with the same ID");                                               // 204
    }                                                                                                           // 205
                                                                                                                //
    if (other.grainId) {                                                                                        // 207
      if (!this.uiView && other.uiView) this.uiView = other.uiView;                                             // 208
      if (!this.hostedObject && other.hostedObject) this.hostedObject = other.hostedObject;                     // 209
    } else if ((this.frontendRef || {}).verifiedEmail) {                                                        // 210
      // If this doesn't have a verifierId but other does, copy it over.                                        //
      if (!this.frontendRef.verifiedEmail.verifierId && other.frontendRef.verifiedEmail.verifierId) {           // 212
        this.frontendRef.verifiedEmail.verifierId = other.frontendRef.verifiedEmail.verifierId;                 // 214
      }                                                                                                         // 215
    }                                                                                                           // 216
  };                                                                                                            // 217
                                                                                                                //
  PowerboxOption.prototype.subtract = function subtract(other) {                                                //
    // Remove `other` from this. Used when `other` is a match deemed unacceptable. Returns true                 //
    // if there's anything left, false otherwise.                                                               //
                                                                                                                //
    if (other._id != this._id) {                                                                                // 223
      throw new Error("can only merge options with the same ID");                                               // 224
    }                                                                                                           // 225
                                                                                                                //
    if (other.grainId) {                                                                                        // 227
      if (this.uiView && other.uiView) delete this.uiView;                                                      // 228
      if (this.hostedObject && other.hostedObject) delete this.hostedObject;                                    // 229
      return !!(this.uiView || this.hostedObject);                                                              // 230
    } else {                                                                                                    // 231
      return false;                                                                                             // 232
    }                                                                                                           // 233
  };                                                                                                            // 234
                                                                                                                //
  return PowerboxOption;                                                                                        //
}();                                                                                                            //
                                                                                                                //
var specialCaseTypes = {};                                                                                      // 237
// This object maps tag IDs to functions which return lists of matches for that tag.                            //
                                                                                                                //
specialCaseTypes[Grain.UiView.typeId] = function (db, userId, value) {                                          // 240
  if (!userId) return [];                                                                                       // 241
                                                                                                                //
  // TODO(someday): Allow `value` to specify app IDs to filter for.                                             //
                                                                                                                //
  var sharedGrainIds = db.userApiTokens(userId).map(function (token) {                                          // 245
    return token.grainId;                                                                                       // 245
  });                                                                                                           // 245
  var ownedGrainIds = db.userGrains(userId).map(function (grain) {                                              // 246
    return grain._id;                                                                                           // 246
  });                                                                                                           // 246
                                                                                                                //
  return _.uniq(sharedGrainIds.concat(ownedGrainIds)).map(function (grainId) {                                  // 248
    return new PowerboxOption({                                                                                 // 249
      _id: "grain-" + grainId,                                                                                  // 250
      grainId: grainId,                                                                                         // 251
      uiView: {}                                                                                                // 252
    });                                                                                                         // 249
  });                                                                                                           // 254
};                                                                                                              // 255
                                                                                                                //
specialCaseTypes[Ip.IpNetwork.typeId] = function (db, userId, value) {                                          // 257
  if (Meteor.users.findOne(userId).isAdmin) {                                                                   // 258
    return [new PowerboxOption({                                                                                // 259
      _id: "frontendref-ipnetwork",                                                                             // 261
      frontendRef: { ipNetwork: true }                                                                          // 262
    })];                                                                                                        // 260
  } else {                                                                                                      // 265
    return [];                                                                                                  // 266
  }                                                                                                             // 267
};                                                                                                              // 268
                                                                                                                //
specialCaseTypes[Ip.IpInterface.typeId] = function (db, userId, value) {                                        // 270
  if (Meteor.users.findOne(userId).isAdmin) {                                                                   // 271
    return [new PowerboxOption({                                                                                // 272
      _id: "frontendref-ipinterface",                                                                           // 274
      frontendRef: { ipInterface: true }                                                                        // 275
    })];                                                                                                        // 273
  } else {                                                                                                      // 278
    return [];                                                                                                  // 279
  }                                                                                                             // 280
};                                                                                                              // 281
                                                                                                                //
specialCaseTypes[Email.EmailVerifier.typeId] = function (db, userId, value) {                                   // 283
  var results = [];                                                                                             // 284
                                                                                                                //
  results.push({                                                                                                // 286
    _id: "emailverifier-all",                                                                                   // 287
    frontendRef: { emailVerifier: {} }                                                                          // 288
  });                                                                                                           // 286
                                                                                                                //
  for (var name in Accounts.identityServices) {                                                                 // 291
    if (Accounts.identityServices[name].isEnabled()) {                                                          // 292
      results.push({                                                                                            // 293
        _id: "emailverifier-" + name,                                                                           // 294
        frontendRef: { emailVerifier: { services: [name] } }                                                    // 295
      });                                                                                                       // 293
    }                                                                                                           // 297
  };                                                                                                            // 298
                                                                                                                //
  return results;                                                                                               // 300
};                                                                                                              // 301
                                                                                                                //
specialCaseTypes[Email.VerifiedEmail.typeId] = function (db, userId, value) {                                   // 303
  var verifierId = value && Capnp.parse(Email.VerifiedEmail.PowerboxTag, value).verifierId.toString("base64");  // 304
  return getVerifiedEmails(db, userId, verifierId).map(function (address) {                                     // 306
    return {                                                                                                    // 306
      _id: "email-" + address,                                                                                  // 307
      frontendRef: { verifiedEmail: { verifierId: verifierId, address: address } }                              // 308
    };                                                                                                          // 306
  });                                                                                                           // 306
};                                                                                                              // 310
                                                                                                                //
function getVerifiedEmails(db, userId, verifierId) {                                                            // 312
  // Get all of the email addresses verified as belonging to the given user using the given                     //
  // verifier.                                                                                                  //
                                                                                                                //
  var services = null;                                                                                          // 316
                                                                                                                //
  if (verifierId) {                                                                                             // 318
    var verifier = db.collections.apiTokens.findOne(verifierId);                                                // 319
    var verifierInfo = ((verifier || {}).frontendRef || {}).emailVerifier;                                      // 320
    if (!verifierInfo) return []; // invalid verifier                                                           // 321
                                                                                                                //
    if (verifierInfo.services) {                                                                                // 323
      // Limit to the listed services.                                                                          //
      services = {};                                                                                            // 325
      verifierInfo.services.forEach(function (service) {                                                        // 326
        return services[service] = true;                                                                        // 326
      });                                                                                                       // 326
    }                                                                                                           // 327
  }                                                                                                             // 328
                                                                                                                //
  var user = Meteor.users.findOne(userId);                                                                      // 330
  var emails = {}; // map address -> true, for uniquification                                                   // 331
  Meteor.users.find({ _id: { $in: SandstormDb.getUserIdentityIds(user) } }).forEach(function (identity) {       // 332
    if (!services || services[identity.profile.service]) {                                                      // 333
      SandstormDb.getVerifiedEmails(identity).forEach(function (email) {                                        // 334
        emails[email.email] = true;                                                                             // 334
      });                                                                                                       // 334
    }                                                                                                           // 335
  });                                                                                                           // 336
                                                                                                                //
  return Object.keys(emails);                                                                                   // 338
}                                                                                                               // 339
                                                                                                                //
Meteor.publish("powerboxOptions", function (requestId, descriptorList) {                                        // 341
  var _this = this;                                                                                             // 341
                                                                                                                //
  // Performs a powerbox query, returning options to present to the user in the powerbox.                       //
  // `descriptorList` is an array of `PowerboxDescriptor`s, each individually serialized in                     //
  // packed format and base64-encoded. The publish populates a pseudo-collection called                         //
  // `powerboxOptions`. Each item has the following fields:                                                     //
  //                                                                                                            //
  //   _id: Unique identifier string.                                                                           //
  //      TODO(soon): This ID string is often a human-readable name like "frontendref-ipinterface"              //
  //        and is only guaranteed to be unique because we currently don't allow a client to have               //
  //        multiple powerbox requests active at the same time. We should strengthen this uniqueness            //
  //        guarentee, possibly by incorporating `requestId`. Note, however, that Meteor requires `_id`         //
  //        to be either a string or an `ObjectID`.                                                             //
  //   requestId: The value of `requestId` that was passed in when subscribing.                                 //
  //   matchQuality: "preferred" or "acceptable" ("unacceptable" options aren't returned).                      //
  //   frontendRef: If present, selecting this option means creating a simple frontendRef. The                  //
  //       field value should be passed back to the method `newFrontendRef` verbatim. The format                //
  //       of the field is the same as ApiTokens.frontendRef.                                                   //
  //   grainId: If present, this option selects a grain to satisfy the request. One or both of                  //
  //       `uiView` and `hostedObject` will be present. Mutually exclusive with `frontendRef`.                  //
  //   uiView: If present, this option creates a UiView for a grain. The UI should allow the user               //
  //       to choose a role to grant. Only present when `grainId` is also present. `uiView` is an               //
  //       object with the fields:                                                                              //
  //     TODO(someday): Some sort of indication of what options the powerbox should give the user               //
  //         as far as which permissions to grant? Unclear if any app would ever want to specify                //
  //         permissions when requesting a plain UiView.                                                        //
  //   hostedObject: If present, this grain advertises that it publishes capabilities that might                //
  //       match the query. If selected, a request session to the grain embedded should be shown                //
  //       embedded in the powerbox and the same request should be passed to it. Only present when              //
  //       `grainId` is also present. `hostedObject`, when present, is (for now) an empty object.               //
                                                                                                                //
  var results = {};                                                                                             // 371
  var db = this.connection.sandstormDb;                                                                         // 372
                                                                                                                //
  if (descriptorList.length > 0) {                                                                              // 374
    var descriptorMatches = descriptorList.map(function (packedDescriptor) {                                    // 375
      // Decode the descriptor.                                                                                 //
      // TODO(now): Also single-segment? Canonical?                                                             //
                                                                                                                //
      // Note: Node's base64 decoder also accepts URL-safe base64, so no need to translate.                     //
      var descriptor = Capnp.parse(Powerbox.PowerboxDescriptor, new Buffer(packedDescriptor, "base64"), { packed: true });
                                                                                                                //
      if (!descriptor.tags || descriptor.tags.length === 0) return {};                                          // 385
                                                                                                                //
      // Expand each tag into a match map.                                                                      //
      var tagMatches = descriptor.tags.map(function (tag) {                                                     // 388
        var type = specialCaseTypes[tag.id];                                                                    // 389
        var result = {};                                                                                        // 390
                                                                                                                //
        if (type) {                                                                                             // 392
          type(db, _this.userId, tag.value).forEach(function (option) {                                         // 393
            result[option._id] = option;                                                                        // 394
          });                                                                                                   // 395
        }                                                                                                       // 396
                                                                                                                //
        return result;                                                                                          // 398
      });                                                                                                       // 399
                                                                                                                //
      // Intersect two tags' matches.                                                                           //
      var matches = tagMatches.reduce(function (a, b) {                                                         // 402
        for (var id in a) {                                                                                     // 403
          if (id in b) {                                                                                        // 404
            if (!a[id].intersect(b[id])) {                                                                      // 405
              // Empty intersection.                                                                            //
              delete a[id];                                                                                     // 407
            }                                                                                                   // 408
          } else {                                                                                              // 409
            // This match only exists in a, not b, so delete it.                                                //
            delete a[id];                                                                                       // 411
          }                                                                                                     // 412
        }                                                                                                       // 413
                                                                                                                //
        return a;                                                                                               // 415
      });                                                                                                       // 416
                                                                                                                //
      return { descriptor: descriptor, matches: matches };                                                      // 418
    });                                                                                                         // 419
                                                                                                                //
    // TODO(someday): The implementation of matchQuality here is not quite right. In theory, we're              //
    //   supposed to compare descriptors to determine which ones are more specific than which                   //
    //   others, and prefer the most-specific match. For now, though, I've implemented a heuristic:             //
    //   consider each descriptor in order. If it is "unacceptable", have it cancel out any                     //
    //   matches seen previously. Otherwise, take the maximum match quality. This will usually                  //
    //   produce the same results as long as "unacceptable" descriptors are placed last in the                  //
    //   list.                                                                                                  //
                                                                                                                //
    var matches = descriptorMatches.reduce(function (finalMatches, clause) {                                    // 429
      if (clause.matchQuality === "unacceptable") {                                                             // 430
        // Remove b's matches from a.                                                                           //
        for (var id in clause.matches) {                                                                        // 432
          if (id in finalMatches) {                                                                             // 433
            if (!finalMatches[id].subtract(clause.matches[id])) {                                               // 434
              delete finalMatches[id];                                                                          // 435
            }                                                                                                   // 436
          }                                                                                                     // 437
        }                                                                                                       // 438
                                                                                                                //
        return finalMatches;                                                                                    // 440
      } else {                                                                                                  // 441
        for (var _id in clause.matches) {                                                                       // 442
          if (_id in finalMatches) {                                                                            // 443
            finalMatches[_id].union(clause.matches[_id]);                                                       // 444
          } else {                                                                                              // 445
            finalMatches[_id] = clause.matches[_id];                                                            // 446
          }                                                                                                     // 447
                                                                                                                //
          if (clause.matchQuality === "preferred") {                                                            // 449
            finalMatches[_id].matchQuality = "preferred";                                                       // 450
          }                                                                                                     // 451
        }                                                                                                       // 452
                                                                                                                //
        return finalMatches;                                                                                    // 454
      }                                                                                                         // 455
    }, {});                                                                                                     // 456
                                                                                                                //
    for (var id in matches) {                                                                                   // 458
      if (!matches[id].matchQuality) {                                                                          // 459
        matches[id].matchQuality = "acceptable";                                                                // 460
      }                                                                                                         // 461
                                                                                                                //
      matches[id].requestId = requestId;                                                                        // 463
      this.added("powerboxOptions", id, matches[id]);                                                           // 464
    }                                                                                                           // 465
  }                                                                                                             // 466
                                                                                                                //
  // TODO(someday): Make reactive? Seems annoying.                                                              //
                                                                                                                //
  this.ready();                                                                                                 // 470
});                                                                                                             // 471
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-ui-powerbox/powerbox-server.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-ui-powerbox'] = {}, {
  SandstormPowerboxRequest: SandstormPowerboxRequest
});

})();

//# sourceMappingURL=sandstorm-ui-powerbox.js.map
